﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Infragistics.Win;
using Infragistics.Win.Misc;

namespace ValidationLeak
{
    public partial class UserInputControl : UserControl
    {
        private UltraValidator m_cycleValidator;
        private string m_ratingNextReviewOld;

        public UserInputControl()
        {
            InitializeComponent();
            AddEventHandlers();
            SetValidation();            
        }

        private void AddEventHandlers()
        {
            m_ratingNextReviewTb.Enter += new EventHandler(m_ratingNextReviewTb_Enter);
            m_ratingNextReviewTb.Leave += new EventHandler(m_ratingNextReviewTb_Leave);
        }


        private void SetValidation()
        {
            m_cycleValidator = new UltraValidator();
            m_cycleValidator.ValidationTrigger = ValidationTrigger.Programmatic;
            ValidationSettings settings = m_cycleValidator.GetValidationSettings(m_ratingNextReviewTb);
            settings.Reset();
            settings.Condition = new RangeCondition(1.0, 365.0, Type.GetType("System.Double"));
            settings.NotificationSettings.Caption = "Next Review Cycle must be between 1 and 365 days.";
            settings.ValidationPropertyName = "Text";
            settings.IsRequired = false;
            settings.EmptyValueCriteria = EmptyValueCriteria.NullOrEmptyString;
            settings.NotificationSettings.Image = Properties.Resources.incomplete;
        }

        private bool ValidateCycle()
        {
            bool result = true;

            Infragistics.Win.Misc.Validation cycleValidation = m_cycleValidator.Validate(m_ratingNextReviewTb);
            if (cycleValidation == null || cycleValidation.IsValid)
            {
                m_daysLb.Appearance.TextHAlign = HAlign.Left;
            }
            else
            {
                m_daysLb.Appearance.TextHAlign = HAlign.Right;
                result = false;
            }

            return result;
        }

        void m_ratingNextReviewTb_Leave(object sender_, EventArgs e_)
        {
            if (ValidateCycle())
            {
                m_ratingNextReviewOld = m_ratingNextReviewTb.Text;
            }
            else
            {
                m_ratingNextReviewTb.Text = m_ratingNextReviewOld;
            }
        }

        void m_ratingNextReviewTb_Enter(object sender_, EventArgs e_)
        {
            m_ratingNextReviewOld = m_ratingNextReviewTb.Text;
        }

    }
}
